# Copyright (c) ECMWF 2020.

from __future__ import absolute_import, unicode_literals

import json
import sys, os

os.environ["METVIEW_PYTHON_START_CMD"] = "/opt/conda/bin/metview"
os.environ["PATH"] = os.getenv("PATH") + ":/opt/conda/bin"
# os.environ["METVIEW_DEBUG"] = "1"
print("TMPDIR={}".format(os.getenv("TMPDIR")))
print("PATH={}".format(os.getenv("PATH")))

print("tmp status", os.path.exists(os.getenv("TMPDIR")))

from servicelib.process import Process
import metview as mv

def run_mv(context, arg):
    print("args", arg)
    print("file=", arg["file"])
    fname = context.get_data(arg["file"])
    print("fname=", fname)
    #arg.pop("location")
    #arg.pop("contentLength")
    arg.pop("file")
    params = arg
    res = context.create_result("application/json")
    print("res={}".format(res))

    f = mv.read(str(fname))

    loc = arg.get("location", [])  #[51, -1] #lat,lon
    if len(loc) != 2:
        raise Exception("Invalid location specified")
    
    val = mv.interpolate(f, loc)
    t = [str(x)for x in mv.valid_date(f)]

    return json.dumps({"values": val, "time": t})

def main():
    from servicelib import service

    service.start_services({"name": "mv_point", "execute": run_mv})
